> For the complete documentation index, see [llms.txt](https://docs.takomo.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.takomo.io/parameter-resolvers/built-in-parameter-resolvers/secret-resolver.md).

# Secret resolver

The secret parameter resolver reads parameter values from secrets stored in Secrets Manager.

### Properties

Here are the properties of the secret parameter resolver:

| Key          | Required | Type    | Description                                                                                                                                            |
| ------------ | -------- | ------- | ------------------------------------------------------------------------------------------------------------------------------------------------------ |
| resolver     | yes      | string  | Resolver name, this must be **secret**.                                                                                                                |
| secretId     | yes      | string  | Secret id.                                                                                                                                             |
| versionId    | no       | string  | Secret version id.                                                                                                                                     |
| versionStage | no       | string  | Secret version stage.                                                                                                                                  |
| commandRole  | no       | string  | IAM role used to access the secret from Secrets Manager. Command role is optional. By default, credentials associated with the current stack are used. |
| region       | no       | string  | Region where the secret resides. By default, Takomo uses the region of the stack where the parameter resolver is used.                                 |
| confidential | no       | boolean | Conceal the resolved parameter value from logs, defaults to **false**                                                                                  |
| immutable    | no       | boolean | Mark the parameter as immutable, defaults to **false**                                                                                                 |

### Examples

Read the parameter value from a secret with id "my-secret-password":&#x20;

```yaml
parameters:
  Password:
    resolver: secret
    secretId: my-secret-password
```

Read the parameter value from a secret in a different region:

```yaml
parameters:
  MyParam:
    resolver: secret
    secretId: my-secret-password
    region: eu-west-1
```

Read the parameter value from a different account

```yaml
parameters:
  MyParam:
    resolver: secret
    secretId: arn:aws:secretsmanager:us-west-2:123456789012:secret:MySecret
    commandRole: arn:aws:iam::123456789012:role/SecretReader
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.takomo.io/parameter-resolvers/built-in-parameter-resolvers/secret-resolver.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
